{
NetXiangqi 1.0
==============

Description  : A program that let's you play chinese chess (Xiang Qi) over TCP
Release date : 10/09/1998
Author       : Axel Fontaine
E-Mail       : axel-fontaine@usa.net
CopyRight    : Axel Fontaine 1998
Cost         : free, or maybe an e-mail to tell me what you think about TXiangqi/NetXiangqi
Version      : 1.0 (initial release)
Recommended config:
  Delphi 3 or higher
  800x600 or higher
  16, 24 or 32 bit color


Legal Issues
============

This component is my creation and the demos are distributed under the GNU GPL.
If you make changes to NetXiangqi, please send them back to me.
The cartoon cliparts are from Corel Mega Gallery (http://www.corel.com).
The TCP/IP component is part of ICS from Franois PIETTE (http://www.rtfm.be/fpiette/indexuk.htm).
The GoToWeb component is from Sylvain CRESTO (http://www.mygale.org/~cresto).
This component and the examples are provided "as-is" with no warranty of any kind.
I may not be held liable for any damage caused by this component or the examples.
You are not allowed to modify or remove the copyright notices in any of the source files.
You cannot claim you wrote these files.
ICS and GoToWeb files distributed for compiling purposes only. 
I stronly recommend you get the full packages at the indicated URLs.
}


unit main;

interface

//To do:
//Small pieces in paintboxes ?

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Xiangqi, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, WSocket, ComCtrls, Winsock, GoToWeb;

const
  ChatPort = '2200';           //Any port would do the job...
  SecretCode = #06#09#19#80;   //Code for data transfer

  //Commands used in data transfer
  MoveCmd             = 1;
  NewGameCmd          = 2;
  NewGameRequestedCmd = 3;
  NewGameDeclinedCmd  = 4;
  UndoCmd             = 5;
  UndoRequestedCmd    = 6;
  UndoDeclinedCmd     = 7;
  NameCmd             = 8;
  ColorCmd            = 9;

  DefaultLocalName    = 'Local';
  DefaultRemoteName   = 'Remote';

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Game1: TMenuItem;
    miNew: TMenuItem;
    Exit1: TMenuItem;
    Memo1: TMemo;
    N1: TMenuItem;
    Pieces1: TMenuItem;
    Cartoon1: TMenuItem;
    Chinese1: TMenuItem;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    miUndo: TMenuItem;
    miActAs: TMenuItem;
    miServer: TMenuItem;
    miClient: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    CliWSocket: TWSocket;
    TmpWSocket: TWSocket;
    SrvWSocket: TWSocket;
    pClient: TPanel;
    Label1: TLabel;
    bConnect: TButton;
    bDisconnect: TButton;
    eMessage: TEdit;
    bSend: TButton;
    Xiangqi1: TXiangqi;
    eServer: TEdit;
    Settings1: TMenuItem;
    miColor: TMenuItem;
    Red1: TMenuItem;
    Green1: TMenuItem;
    pbTurnRed: TPaintBox;
    pbTurnGreen: TPaintBox;
    Label2: TLabel;
    eName: TEdit;
    GoToWeb1: TGoToWeb;
    Gamerules1: TMenuItem;
    procedure miNewClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Xiangqi1Check(Sender: TObject; Player: TPlayerColor);
    procedure Xiangqi1Mate(Sender: TObject; Player: TPlayerColor; MateType: TMateType);
    procedure Xiangqi1Move(Sender: TObject; StartPos, EndPos: TPoint);
    procedure Chinese1Click(Sender: TObject);
    procedure Cartoon1Click(Sender: TObject);
    procedure Xiangqi1Capture(Sender: TObject; StartPos, EndPos: TPoint; CapturedPiece: PPieceInfo);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure Xiangqi1PieceSetChange(Sender: TObject; NewPieceSet: TPieceSet);
    procedure Xiangqi1PreviousMove(Sender: TObject);
    procedure Xiangqi1Resurrect(Sender: TObject; Piece: PPieceInfo);
    procedure bConnectClick(Sender: TObject);
    procedure CliWSocketSessionConnected(Sender: TObject; Error: Word);
    procedure CliWSocketSessionClosed(Sender: TObject; Error: Word);
    procedure CliWSocketDataAvailable(Sender: TObject; Error: Word);
    procedure SrvWSocketSessionAvailable(Sender: TObject; Error: Word);
    procedure bDisconnectClick(Sender: TObject);
    procedure bSendClick(Sender: TObject);
    procedure miServerClick(Sender: TObject);
    procedure miClientClick(Sender: TObject);
    procedure CliWSocketDnsLookupDone(Sender: TObject; Error: Word);
    procedure Red1Click(Sender: TObject);
    procedure Green1Click(Sender: TObject);
    procedure eMessageKeyPress(Sender: TObject; var Key: Char);
    procedure pbTurnGreenPaint(Sender: TObject);
    procedure pbTurnRedPaint(Sender: TObject);
    procedure miUndoClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Gamerules1Click(Sender: TObject);
  private
    Connected: Boolean;
    LocalName: String;
    RemoteName: String;
    Player: TPlayerColor;
    RcvBuf: array [0..1023] of char;
    RcvLen: integer;
    TurnBitmap: TBitmap;
    procedure NewGame;
    procedure StartServer;
    procedure UpdateCaption;
  public
    CapturedPieces1, CapturedPieces2: TList;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$R TurnBMP.Res}

uses
  About;

const
  TurnBMPRes = 'TurnBMP';

procedure TForm1.StartServer;
begin
  { Try to be a server }
  SrvWSocket.Port  := ChatPort;
  SrvWSocket.Proto := 'tcp';
  SrvWSocket.Addr  := '0.0.0.0';
  try
    SrvWSocket.Listen;
  except
    on E:ESocketException do
      begin
         if Copy(E.Message, 1, 11) = 'Error 10048' then
           begin
             Memo1.Lines.Add('Xiangqi Demo already running as server');
             miClient.Click;
             Memo1.Lines.Add('Switched to client mode');
           end
         else
           raise;
      end
    else
      raise;
  end;
end;

procedure TForm1.UpdateCaption;
begin
  If Connected Then
    Caption := LocalName+'(local) vs '+RemoteName+'(remote) - NetXiangqi 1.0 by Axel Fontaine'
  Else
    Caption := 'NetXiangqi 1.0 by Axel Fontaine';
end;

procedure TForm1.NewGame;
begin
  Memo1.Lines.Add('Starting a new game');
  CapturedPieces1.Clear;
  CapturedPieces2.Clear;
  PaintBox1.Refresh;
  PaintBox2.Refresh;
  Xiangqi1.NewGame;
  pbTurnRed.Visible := True;
  pbTurnGreen.Visible := False;
  If Player = pcRed Then Xiangqi1.Playing := True Else Xiangqi1.Playing := False;
end;

procedure TForm1.miNewClick(Sender: TObject);
begin
  Memo1.Lines.Add('Requesting new game ...');
  CliWSocket.SendStr(SecretCode+Char(NewGameRequestedCmd)+#13#10);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Xiangqi1Check(Sender: TObject; Player: TPlayerColor);
var
  Str: String;

begin
  If Player = pcRed Then Str := 'Red' Else Str := 'Green';
  Str := Str + ' is in check !';
  Memo1.Lines.Add(Str);
end;

procedure TForm1.Xiangqi1Mate(Sender: TObject; Player: TPlayerColor;
  MateType: TMateType);
var
  Str: String;

begin
  If Player = pcRed Then Str := 'Green' Else Str := 'Red';
  Str := Str + ' wins by ';
  If MateType = mtCheckMate Then Str := Str + 'checkmate' Else Str := Str + 'stalemate';
  Str := Str + ' !';
  Memo1.Lines.Add(Str);
end;

procedure TForm1.Xiangqi1Move(Sender: TObject; StartPos, EndPos: TPoint);
begin
  If Xiangqi1[EndPos.X,EndPos.Y].Color = Player Then
    Begin
      CliWSocket.SendStr(SecretCode+Char(MoveCmd)+
                         IntToStr(StartPos.X)+IntToStr(StartPos.Y)+
                         IntToStr(EndPos.X)+IntToStr(EndPos.Y)+#13#10);
      Xiangqi1.Playing := False;
    End
  Else
    Xiangqi1.Playing := True;
  pbTurnRed.Visible := Xiangqi1.Turn = pcGreen;
  pbTurnGreen.Visible := Not pbTurnRed.Visible;
end;

procedure TForm1.Chinese1Click(Sender: TObject);
begin
  Chinese1.Checked := True;
  Xiangqi1.PieceSet := psChinese;
end;

procedure TForm1.Cartoon1Click(Sender: TObject);
begin
  Cartoon1.Checked := True;
  Xiangqi1.PieceSet := psCartoon;
end;

procedure TForm1.Xiangqi1Capture(Sender: TObject; StartPos, EndPos: TPoint;
  CapturedPiece: PPieceInfo);
var
  List: TList;
  PaintBox: TPaintBox;

begin
  If Xiangqi1.Turn = pcRed Then
    Begin
      PaintBox := PaintBox1;
      List := CapturedPieces1;
    End
  Else
    Begin
      PaintBox := PaintBox2;
      List := CapturedPieces2;
    End;
  List.Add(CapturedPiece);
  PaintBox.Refresh;
  Xiangqi1Move(Sender,StartPos,EndPos);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  I: Integer;

begin
  For I := 0 To Pred(CapturedPieces1.Count) Do
{    PaintBox1.Canvas.StretchDraw(
                       TRect(Point((I mod 5)* PieceWidth,(I div 5)* PieceWidth)),
                       Xiangqi1.PieceBitmap[CapturedPieces1[I].PieceIndex]);}
    Xiangqi1.DrawPiece(PaintBox1.Canvas,
                       Point((I mod 5)* PieceWidth,(I div 5)* PieceWidth),
                       CapturedPieces1[I]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  GotoWeb1.Url := ExtractFilePath(Application.Exename) + GotoWeb1.Url;
  CapturedPieces1 := TList.Create;
  CapturedPieces2 := TList.Create;
  TurnBitmap := TBitmap.Create;
  TurnBitmap.LoadFromResourceName(HInstance,TurnBMPRes);
  pbTurnRed.Canvas.Brush.Color := Color;
  pbTurnGreen.Canvas.Brush.Color := Color;
  LocalName := DefaultLocalName;
  RemoteName := DefaultremoteName;
  StartServer;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  TurnBitmap.Free;
  CapturedPieces2.Free;
  CapturedPieces1.Free;
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
var
  I: Integer;

begin
  For I := 0 To Pred(CapturedPieces2.Count) Do
    Xiangqi1.DrawPiece(PaintBox2.Canvas,
                       Point((I mod 5)* PieceWidth,(I div 5)* PieceWidth),
                       CapturedPieces2[I]);
end;

procedure TForm1.Xiangqi1PieceSetChange(Sender: TObject;
  NewPieceSet: TPieceSet);
begin
  PaintBox1.Refresh;
  PaintBox2.Refresh;
end;

procedure TForm1.Xiangqi1PreviousMove(Sender: TObject);
begin
  Memo1.Lines.Add('Undo accepted');
end;

procedure TForm1.Xiangqi1Resurrect(Sender: TObject; Piece: PPieceInfo);
begin
  If Xiangqi1.Turn = pcRed Then
    Begin
      CapturedPieces1.Delete(Pred(CapturedPieces1.Count));
      PaintBox1.Refresh;
    End
  Else
    Begin
      CapturedPieces2.Delete(Pred(CapturedPieces2.Count));
      PaintBox2.Refresh;
    End;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ The user has clicked on the 'connect' button. We will not connect here,   }
{ but start the DNSLookup. We will receive a event when it is complete.     }
{ The connection will be made at that later time.                           }
procedure TForm1.bConnectClick(Sender: TObject);
begin
  bConnect.Enabled := False;
  bDisconnect.Enabled := True;
  eServer.Enabled := False;
  CliWSocket.DnsLookup(eServer.Text);
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ This event handler is triggered when the connection is established with   }
{ the server. Enable the send button and the message edit box.              }
procedure TForm1.CliWSocketSessionConnected(Sender: TObject; Error: Word);
begin
  Case Error Of
    WSAECONNREFUSED:
      Memo1.Lines.Add('No server available');

    0:
      begin
        Memo1.Lines.Add('Connected');
        bSend.Enabled  := True;
        eMessage.Enabled := True;
        miColor.Enabled := False;
        miActAs.Enabled := False;
        miNew.Enabled := True;
        miUndo.Enabled := True;
        eName.Enabled := False;
        LocalName := eName.Text;
        CliWSocket.SendStr(SecretCode+Char(NameCmd)+LocalName+#13#10);
        Connected := True;
        UpdateCaption;
        Green1.Click;
        NewGame;
      end;

    else
      Memo1.Lines.Add('Can''t connect, error #' + IntToStr(Error))
  End;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ This event is triggered when the client connection is closed, either      }
{ by the client himself or by the local user pushing the disconnect button  }
procedure TForm1.CliWSocketSessionClosed(Sender: TObject; Error: Word);
begin
  bDisconnect.Enabled := False;
  bConnect.Enabled := Not miServer.Checked;
  eServer.Enabled := Not miServer.Checked;
  bSend.Enabled := False;
  eMessage.Enabled := False;
  miColor.Enabled := True;
  miActAs.Enabled := True;
  miNew.Enabled := False;
  miUndo.Enabled := False;
  eName.Enabled := True;
  Connected := False;
  UpdateCaption;
  Memo1.Lines.Add('Disconnected');
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ This event is triggered when data has been received from the client.      }
{ A little bit of work here because the data can comes fragmented or in big }
{ chunks with several client lines. So we assemble the data received in a   }
{ buffer and check the buffer for complete lines (there can be no complete  }
{ line, exactly one complete line, several complete lines and may be an     }
{ incomplete line at the end.                                               }
procedure TForm1.CliWSocketDataAvailable(Sender: TObject; Error: Word);
var
  Len : Integer;
  I   : Integer;
  Base : Cardinal;
  Tmp : String;

begin
  { Receive the data that has arrived, put it after the data already here }
  Len := CliWSocket.Receive(@RcvBuf[RcvLen], SizeOf(RcvBuf) - RcvLen - 1);
  if Len <= 0 then Exit;
  { Update our conter }
  RcvLen := RcvLen + Len;
  { Place a null byte at the end of the buffer }
  RcvBuf[RcvLen] := #0;

  { Scan the buffer to process each complete line }
  while TRUE do
    begin
      { find the terminating line feed }
      I := StrScan(@RcvBuf, #10) - RcvBuf;
      if I < 0 then break; { not found, incomplete line, break loop }
      { Replace the line feed by a nul char, truncating the line }
      RcvBuf[I] := #0;  //replace #13
      { Display the truncated line }
      Tmp := StrPas(RcvBuf);
      Base := 1;
      If Copy(Tmp,Base,Length(SecretCode)) = SecretCode Then
        Begin
          Base := Base + Length(SecretCode);
          Case Byte(Tmp[Base]) Of
            MoveCmd:
              If Xiangqi1.Turn = TXiangqi.OtherColor(Player) Then
                Xiangqi1.DoMove(Point(StrToInt(Tmp[Base+1]),StrToInt(Tmp[Base+2])),
                                Point(StrToInt(Tmp[Base+3]),StrToInt(Tmp[Base+4])));

            ColorCmd:
              Player := TXiangqi.OtherColor(TPlayerColor(StrToInt(Tmp[Succ(Base)])));

            NameCmd:
              Begin
                RemoteName := Copy(Tmp,Succ(Base),Length(Tmp)-Succ(Base));
                UpdateCaption;
              End;

            NewGameRequestedCmd:
              If Application.MessageBox(
                   PChar(RemoteName+' wants to start a new game.'+#13#10+'Do you accept ?'),
                   PChar('New game request'),
                   MB_ICONQUESTION + MB_YESNO) = IDYES Then
                Begin
                  CliWSocket.SendStr(SecretCode+Char(NewGameCmd)+#13#10);
                  NewGame;
                End
              Else
                CliWSocket.SendStr(SecretCode+Char(NewGameDeclinedCmd)+#13#10);

            NewGameCmd:
              NewGame;

            NewGameDeclinedCmd:
              Memo1.Lines.Add('New game declined.');

            UndoRequestedCmd:
              If Application.MessageBox(
                   PChar(RemoteName+' wants to replay his/her last move.'+#13#10+'Do you accept ?'),
                   PChar('Undo request'),
                   MB_ICONQUESTION + MB_YESNO) = IDYES Then
                Begin
                  CliWSocket.SendStr(SecretCode+Char(UndoCmd)+#13#10);
                  Xiangqi1.PreviousMove;
                  Xiangqi1.Playing := False;
                End
              Else
                CliWSocket.SendStr(SecretCode+Char(UndoDeclinedCmd)+#13#10);

            UndoCmd:
              Begin
                Xiangqi1.PreviousMove;
                Xiangqi1.Playing := True;
              End;

            UndoDeclinedCmd:
              Memo1.Lines.Add('Undo declined.');

            Else
              Memo1.Lines.Add('Received unknown command from '+RemoteName);
          End;
        End
      Else
        Memo1.Lines.Add(RemoteName+'> '+Tmp);
      { Restore the line feed }
      RcvBuf[I] := #10;
      { Was it the last line in the buffer ? }
      if I >= (RcvLen - 1) then
        begin
          RcvLen := 0;
          break;
        end;
      { Not the last line, move the next one in front of buffer }
      Move(RcvBuf[I + 1], RcvBuf, RcvLen - I);
      RcvLen := RcvLen - I - 1;
    end;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ This event is triggered when we - as a server - have received a client    }
{ connection request. We must accept the connection. Two cases: we are      }
{ already busy with another client, or this is the first client connecting. }
procedure TForm1.SrvWSocketSessionAvailable(Sender: TObject; Error: Word);
begin
  if CliWSocket.State = wsConnected then
    begin
      { We are already busy with a client. Use the TmpWSocket to send a }
      { busy message to the second client. Display a message to notify  }
      { the user that someone is trying to contact him.                 }
      TmpWSocket.HSocket := SrvWSocket.Accept;
      Memo1.Lines.Add('System> ' + TmpWSocket.GetPeerAddr + ' is trying to call you');
      TmpWSocket.SendStr('Busy ! Try later...' + #13#10);
      TmpWSocket.Close;
      Exit;
    end;

  { This is our first client trying to connect, we accept }
  CliWSocket.HSocket := SrvWSocket.Accept;
  bConnect.Enabled := False;
  bDisconnect.Enabled := True;
  bSend.Enabled := True;
  eMessage.Enabled := True;
  miColor.Enabled := False;
  miActAs.Enabled := False;
  miUndo.Enabled := True;
  miNew.Enabled := True;
  Memo1.Lines.Add('Connected with ' + CliWSocket.GetPeerAddr);
  eName.Enabled := False;
  LocalName := eName.Text;
  CliWSocket.SendStr(SecretCode+Char(NameCmd)+LocalName+#13#10);
  UpdateCaption;
  Connected := True;
  CliWSocket.SendStr(SecretCode+Char(ColorCmd)+IntToStr(Integer(Player))+#13#10);
  NewGame;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ The user clicked on the disconnect button.                                }
procedure TForm1.bDisconnectClick(Sender: TObject);
begin
  Connected := False;
  CliWSocket.Close;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ The user has clicked on the send button. Just send the data in the edit   }
{ box and a CRLF pair to make a complete line.                              }
procedure TForm1.bSendClick(Sender: TObject);
begin
  CliWSocket.SendStr(eMessage.Text + #13#10);
  Memo1.Lines.Add(LocalName+'> ' + eMessage.Text);
  eMessage.Text := '';
end;

procedure TForm1.miServerClick(Sender: TObject);
begin
  If Not miServer.Checked Then
    Begin
      miServer.Checked := True;
      If SrvWSocket.State <> wsListening then StartServer;
      bConnect.Enabled := False;
      bDisconnect.Enabled := False;
      eServer.Enabled := False;
      miColor.Enabled := True;
    End;
end;

procedure TForm1.miClientClick(Sender: TObject);
begin
  If Not miClient.Checked Then
    Begin
      miClient.Checked := True;
      SrvWSocket.Close;
      bConnect.Enabled := True;
      eServer.Enabled := True;
      miColor.Enabled := False;
    End;
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ This event handler is triggered when the DNS lookup process is finished   }
{ successfully or not. If DNS lookud failed, display a message.             }
{ If DNS lookup successfull, ask TWSocket to connect the server.            }
procedure TForm1.CliWSocketDnsLookupDone(Sender: TObject; Error: Word);
begin
  if Error <> 0 then
    begin
      { DNS Lookup has failed }
      Memo1.Lines.Add('Server name unknown');
      bConnect.Enabled    := True;
      bDisconnect.Enabled := False;
      Exit;
    end;

  { DNS lookup successfull. Try to see if we are the server and we are }
  { trying to connect to ourself. Check loopback address, should also  }
  { check the local IP address (returned by LocalIPList)...            }
  if (SrvWSocket.State = wsListening) and
     (CliWSocket.DnsResult = '127.0.0.1') then
    begin
      Memo1.Lines.Add('Your are trying to connect to yourself !');
      bConnect.Enabled := True;
      bDisconnect.Enabled := False;
      Exit;
    end;

  { Transfert the IP address from DNSLookup to the TWSocket for connection }
  { We could use the hostname for the Addr property, TWSocket will do the  }
  { DNS lookup for us, but it will block, maybe for a long time if DNS if  }
  { down.                                                                  }
  CliWSocket.Addr  := CliWSocket.DnsResult;
  CliWSocket.Port  := ChatPort;
  CliWSocket.Proto := 'tcp';

  { The connect method is asynchronous. You get the control back quickly }
  { The OnSessionConnected event will be eventually generated when the   }
  { connection is established.                                           }
  CliWSocket.Connect;
end;

procedure TForm1.Red1Click(Sender: TObject);
begin
  Player := pcRed;
  Red1.Checked := True;
end;

procedure TForm1.Green1Click(Sender: TObject);
begin
  Player := pcGreen;
  Green1.Checked := True;
end;

procedure TForm1.eMessageKeyPress(Sender: TObject; var Key: Char);
begin
  If Key = #13 Then
    Begin
      bSend.Click;
      Key := #0;
    End;
end;


procedure TForm1.pbTurnGreenPaint(Sender: TObject);
begin
  pbTurnGreen.Canvas.BrushCopy(pbTurnGreen.ClientRect,TurnBitmap,TurnBitmap.Canvas.ClipRect,TurnBitmap.Canvas.Pixels[0,0]);
end;

procedure TForm1.pbTurnRedPaint(Sender: TObject);
begin
  pbTurnRed.Canvas.BrushCopy(pbTurnRed.ClientRect,TurnBitmap,TurnBitmap.Canvas.ClipRect,TurnBitmap.Canvas.Pixels[0,0]);
end;

procedure TForm1.miUndoClick(Sender: TObject);
begin
  If Xiangqi1.Turn = TXiangqi.OtherColor(Player) Then
    Begin
      CliWSocket.SendStr(SecretCode+Char(UndoRequestedCmd)+#13#10);
      Memo1.Lines.Add('Undo requested ...');
    End;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  fAbout.ShowModal;
end;

procedure TForm1.Gamerules1Click(Sender: TObject);
begin
  While Not GoToWeb1.IsAnyBrowser Do
    If Application.MessageBox('Browser not found.',
                              'Error',
                              MB_IconError+MB_RetryCancel)=IDCancel Then Exit;
  If Not GoToWeb1.Execute Then
    Application.MessageBox('Connection failed.','Error',MB_IconError+MB_OK);

end;

end.
